#!/bin/sh 
exec_option=$1
VLAN_LAN_CONF="/etc/network/lan.conf"
VLAN_WAN_CONF="/etc/network/wan.conf"
RTL8309="/proc/rtl8309"

#Set RTL8309
if [ -f $VLAN_LAN_CONF ]
then
	. $VLAN_LAN_CONF

	#vlan for eth0
	ENABLEVLAN_LAN=$ENABLEVLAN
	VLANID_LAN=$VLANID
	VLANPRIORITY_LAN=$VLANPRIORITY

	#vlan for eth0.x
	ENABLEVLAN_LAN1=$ENABLEVLAN1
	VLANID_LAN1=$VLANID1
	VLANPRIORITY_LAN1=$VLANPRIORITY1
	VLANIPADDRESS_LAN1=$VLANIPADDRESS1
	VLANNETMASK_LAN1=$VLANNETMASK1
	VLANGATEWAY_LAN1=$VLANGATEWAY1

	#vlan for eth0.y
	ENABLEVLAN_LAN2=$ENABLEVLAN2
	VLANID_LAN2=$VLANID2
	VLANPRIORITY_LAN2=$VLANPRIORITY2
	VLANIPADDRESS_LAN2=$VLANIPADDRESS2
	VLANNETMASK_LAN2=$VLANNETMASK2
	VLANGATEWAY_LAN2=$VLANGATEWAY2

	if [ ! -z $ENABLESWITCH ] && [ "$ENABLESWITCH" = yes ] && [ ! -f $VLAN_WAN_CONF ]
	then
		echo "switch mode" >$RTL8309
	fi
	#vlan for eth0
	if [ "$ENABLEVLAN_LAN" = yes ]
	then
		echo "Set VLAN on Lan($VLANID_LAN,$VLANPRIORITY_LAN)"
		echo "set lan port vlan $VLANID_LAN $VLANPRIORITY_LAN" >$RTL8309

		DHCPCDPID_LAN=`ps |grep "dhcpcd" | grep "eth0" |grep -v grep |awk '{print$1}'|tr -d "\n"`;
		if [[ -n "$DHCPCDPID_LAN" ]] ;
		then
			dhcpcd -n eth0
		fi
	fi
	#vlan for eth0.x
	if [ "$ENABLEVLAN_LAN1" = yes ]
	then
		echo "Set VLAN1 on Lan($VLANID_LAN1,$VLANPRIORITY_LAN1)"
		echo "add lan port vlan $VLANID_LAN1" >$RTL8309
		/sbin/vconfig add eth0 $VLANID_LAN1
		/sbin/vconfig set_egress_map eth0.$VLANID_LAN1 0 $VLANPRIORITY_LAN1
		ifconfig eth0.$VLANID_LAN1 $VLANIPADDRESS_LAN1 netmask $VLANNETMASK_LAN1 up
		if [[ -n "$VLANGATEWAY_LAN1" ]];
		then
			echo "Set Default GW on Vlan1<>Lan"
			/sbin/route add default gw $VLANGATEWAY_LAN1 dev eth0.$VLANID_LAN1
		fi
	fi
	#vlan for eth0.y
	if [ "$ENABLEVLAN_LAN2" = yes ]
	then
		echo "Set VLAN2 on Lan($VLANID_LAN2,$VLANPRIORITY_LAN2)"
		echo "add lan port vlan $VLANID_LAN2" >$RTL8309
		/sbin/vconfig add eth0 $VLANID_LAN2
		/sbin/vconfig set_egress_map eth0.$VLANID_LAN2 0 $VLANPRIORITY_LAN2
		ifconfig eth0.$VLANID_LAN2 $VLANIPADDRESS_LAN2 netmask $VLANNETMASK_LAN2
		if [[ -n "$VLANGATEWAY_LAN2" ]];
		then
			echo "Set Default GW on Vlan2<>Lan"
			/sbin/route add default gw $VLANGATEWAY_LAN2 dev eth0.$VLANID_LAN2
		fi
	fi
fi
if [ -f $VLAN_WAN_CONF ]
then
	#echo "dual mode" >/proc/rtl8309
	. $VLAN_WAN_CONF

	#vlan for eth0
	ENABLEVLAN_WAN=$ENABLEVLAN
	VLANID_WAN=$VLANID
	VLANPRIORITY_WAN=$VLANPRIORITY

	#vlan for eth0.x
	ENABLEVLAN_WAN1=$ENABLEVLAN1
	VLANID_WAN1=$VLANID1
	VLANPRIORITY_WAN1=$VLANPRIORITY1
	VLANIPADDRESS_WAN1=$VLANIPADDRESS1
	VLANNETMASK_WAN1=$VLANNETMASK1
	VLANGATEWAY_WAN1=$VLANGATEWAY1

	#vlan for eth0.y
	ENABLEVLAN_WAN2=$ENABLEVLAN2
	VLANID_WAN2=$VLANID2
	VLANPRIORITY_WAN2=$VLANPRIORITY2
	VLANIPADDRESS_WAN2=$VLANIPADDRESS2
	VLANNETMASK_WAN2=$VLANNETMASK2
	VLANGATEWAY_WAN2=$VLANGATEWAY2

	#vlan for eth1
	if [ "$ENABLEVLAN_WAN" = yes ]
	then
		echo "Set VLAN on Wan($VLANID_WAN,$VLANPRIORITY_WAN)"
		echo "set wan port vlan $VLANID_WAN $VLANPRIORITY_WAN" >$RTL8309

		DHCPCDPID_WAN=`ps |grep "dhcpcd" | grep "eth1" |grep -v grep |awk '{print$1}'|tr -d "\n"`;
		if [[ -n "$DHCPCDPID_WAN" ]] ;
		then
			dhcpcd -n eth1
		fi
	fi
	#vlan for eth1.w
	if [ "$ENABLEVLAN_WAN1" = yes ]
	then
		echo "Set VLAN1 on Wan($VLANID_WAN1,$VLANPRIORITY_WAN1)"
		echo "add wan port vlan $VLANID_WAN1" >$RTL8309
		/sbin/vconfig add eth1 $VLANID_WAN1
		/sbin/vconfig set_egress_map eth1.$VLANID_WAN1 0 $VLANPRIORITY_WAN1
		ifconfig eth1.$VLANID_WAN1 $VLANIPADDRESS_WAN1 netmask $VLANNETMASK_WAN1
		if [[ -n "$VLANGATEWAY_WAN1" ]];
		then
			echo "Set Default GW on Vlan1<>Wan"
			/sbin/route add default gw $VLANGATEWAY_WAN1 dev eth1.$VLANID_WAN1
		fi
	fi
	#vlan for eth1.z
	if [ "$ENABLEVLAN_WAN2" = yes ]
	then
		echo "Set VLAN2 on Wan($VLANID_WAN2,$VLANPRIORITY_WAN2)"
		echo "add wan port vlan $VLANID_WAN2" >$RTL8309
		/sbin/vconfig add eth1 $VLANID_WAN2
		/sbin/vconfig set_egress_map eth1.$VLANID_WAN2 0 $VLANPRIORITY_WAN2
		ifconfig eth1.$VLANID_WAN2 $VLANIPADDRESS_WAN2 netmask $VLANNETMASK_WAN2
		if [[ -n "$VLANGATEWAY_WAN2" ]];
		then
			echo "Set Default GW on Vlan2<>Wan"
			/sbin/route add default gw $VLANGATEWAY_WAN2 dev eth1.$VLANID_WAN2
		fi
	fi
fi

#End set RTL8309


